-- module_ofap.lua: On-Foot Audio Player for SRTT [nclok1405]

-- This mod uses codes from "Sandbox+ for SRTT" by IdolNinja and other contributors
-- https://www.saintsrowmods.com/forum/threads/sandbox-for-srtt.1076/
-- This mod also uses codes from "Sandbox+ - Things To Do In Steelport Edition" by Fan of Saints and other contributors
-- https://www.saintsrowmods.com/forum/threads/sandbox-things-to-do-in-steelport-edition.14440/

-- *** SONG TITLE DISPLAY ***
-- false: Do not show
-- true: Show song title when a new song plays
OFAP_SHOW_SONG_TITLE = true

-- *** VANILLA CAR RADIO ***
-- Change this to true if you want to leave the in-game car radio untouched
OFAP_CAR_RADIO = false

-- *** ON-FOOT RADIO RANDOMIZE SETTINGS ***
-- OFAP_SHUFFLE = false has all on-foot radio play in the order you see them below in the OFAP_RADIODATA table
-- OFAP_SHUFFLE = true (default) forces all on-foot radio to auto shuffle on load
OFAP_SHUFFLE = false

-- ** ON-FOOT MIXTAPE PLAYLIST TRACK SETTINGS ***
-- NOTE: This applies to each entry in the following OFAP_RADIODATA table; including songs, commercials, newscasts, etc
-- mixtape = true  will add the track to your on-foot Custom Playlist
-- mixtape = false (default) will exclude that track from your on-foot custom playlist

OFAP_RADIODATA =
{
	-- THE MIXX
	{ mixtape = false	,SongString = "Adam Ant - Stand and Deliver",					SongData = "MIX_ADAM_ANT___STAND_AND_DELIVER",				station = "MIXX" },
	{ mixtape = false	,SongString = "Aldo Nova - Fantasy",						SongData = "MIX_ALDO_NOVA___FANTASY",					station = "MIXX" },
	{ mixtape = false	,SongString = "Bonnie Tyler - Holding out for a Hero",				SongData = "MIX_BONNIE_TYLER___HOLDING_OUT_FOR_A_HERO",			station = "MIXX" },
	{ mixtape = false	,SongString = "Bush - Machinehead",						SongData = "MIX_BUSH___MACHINEHEAD",					station = "MIXX" },
	{ mixtape = false	,SongString = "The Butthole Surfers - Pepper",					SongData = "MIX_BUTTHOLE_SURFERS___PEPPER",				station = "MIXX" },
	{ mixtape = false	,SongString = "Faith no More - Epic",						SongData = "MIX_FAITH_NO_MORE___EPIC",					station = "MIXX" },
	{ mixtape = false	,SongString = "Frankie Goes to Hollywood - Relax",				SongData = "MIX_FRANKIE_GOES_TO_HOLLYWOOD___RELAX",			station = "MIXX" },
	{ mixtape = false	,SongString = "The Icicle Works - Birds Fly Whisper to a Scream",		SongData = "MIX_THE_ICICLE_WORKS___BIRDS_FLY_WHISPER_TO_A_SCREAM",	station = "MIXX" },
	{ mixtape = false	,SongString = "Joe Esposito - You're the Best Around",				SongData = "MIX_JOE_BEAN_ESPOSITO___YOURE_THE_BEST",			station = "MIXX" },
	{ mixtape = false	,SongString = "Mark Morrison - Return of the Mack",				SongData = "MIX_MARK_MORRISON___RETURN_OF_THE_MACK",			station = "MIXX" },
	{ mixtape = false	,SongString = "Motley Crue - Live Wire",					SongData = "MIX_MOTLEY_CRUE___LIVE_WIRE",				station = "MIXX" },
	{ mixtape = false	,SongString = "Motley Crue - Shout at the Devil",				SongData = "MIX_MOTLEY_CRUE___SHOUT_AT_THE_DEVIL",			station = "MIXX" },
	{ mixtape = false	,SongString = "Robert Tepper - No Easy Way Out",				SongData = "MIX_ROBERT_TEPPER___NO_EASY_WAY_OUT",			station = "MIXX" },
	{ mixtape = false	,SongString = "Run DMC - My Adidas",						SongData = "MIX_RUN_DMC___MY_ADIDAS",					station = "MIXX" },
	{ mixtape = false	,SongString = "Social Distortion - Ball and Chain",				SongData = "MIX_SOCIAL_DISTORTION___BALL_AND_CHAIN",			station = "MIXX" },
	{ mixtape = false	,SongString = "Sublime - What I Got",						SongData = "MIX_SUBLIME___WHAT_I_GOT",					station = "MIXX" },
	{ mixtape = false	,SongString = "Talk Talk - It's My Life",					SongData = "MIX_TALK_TALK___ITS_MY_LIFE",				station = "MIXX" },
	{ mixtape = false	,SongString = "Tone Loc - Funky Cold Medina",					SongData = "MIX_TONE_LOC___FUNKY_COLD_MEDINA",				station = "MIXX" },

	-- K12
	{ mixtape = false	,SongString = "Baobinga - State of Ghetto Jackin feat. DJ Nasty",		SongData = "K12_BAOBINGA___STATE_OF_GHETTO_JACKIN",			station = "K12" },
	{ mixtape = false	,SongString = "Benny Benassi - Satisfaction",					SongData = "K12_BENNY_BENASSI___SATISFACTION",				station = "K12" },
	{ mixtape = false	,SongString = "The Bloody Beetroots - 31 Seconds To Die",			SongData = "K12_THE_BLOODY_BEETROOTS___31_SECONDS_TO_DIE",		station = "K12" },
	{ mixtape = false	,SongString = "Deadmau5 - A City in Florida",					SongData = "K12_DEADMAU5___A_CITY_IN_FLORIDA",				station = "K12" },
	{ mixtape = false	,SongString = "Digitalism - Idealistic",					SongData = "K12_DIGITALISM___IDEALISTIC",				station = "K12" },
	{ mixtape = false	,SongString = "Dilemn - Pitiless",						SongData = "K12_DILEMN___PITILESS",					station = "K12" },
	{ mixtape = false	,SongString = "Divalola - Wallflower",						SongData = "K12_KEVIN_AND_CARRICK___WALLFLOWERS",			station = "K12" },
	{ mixtape = false	,SongString = "Grum - Heartbeats",						SongData = "K12_GRUM___HEARTBEATS",					station = "K12" },
	{ mixtape = false	,SongString = "Jesse No - Double Bubble",					SongData = "K12_JESSE_NO___DOUBLE_BUBBLE",				station = "K12" },
	{ mixtape = false	,SongString = "Jesse No - OH NO U DON'T",					SongData = "K12_JESSE_NO___OH_NO_U_DONT",				station = "K12" },
	{ mixtape = false	,SongString = "Jokers of the Scene - Baggy Bottom Boys",			SongData = "K12_BAGGY_BOTTOM_BOYS___JOKERS_ON_THE_SCENE",		station = "K12" },
	{ mixtape = false	,SongString = "Junkie XL - Angry Elephants",					SongData = "K12_JUNKIE_XL___ANGRY_ELEPHANTS",				station = "K12" },
	{ mixtape = false	,SongString = "Kevin Seaton - Scrub Down",					SongData = "K12_KEVIN_SEATON___SCRUB_DOWN",				station = "K12" },
	{ mixtape = false	,SongString = "MNDR - C.L.U.B.",						SongData = "K12_MNDR___C_L_U_B",					station = "K12" },
	{ mixtape = false	,SongString = "Ratatat - Neckbrace",						SongData = "K12_RATATAT___NECKBRACE",					station = "K12" },
	{ mixtape = false	,SongString = "Rusko - Woo Boost",						SongData = "K12_RUSKO___WOO_BOOST",					station = "K12" },
	{ mixtape = false	,SongString = "Tugboat - Don't Break It",					SongData = "K12_TUGBOAT___DONT_BREAK_IT",				station = "K12" },

	-- BLOOD
	{ mixtape = false	,SongString = "After the Burial - Berzerker",					SongData = "KRUNCH_AFTER_THE_BURIAL___BEZERKER",			station = "KRUNCH" },
	{ mixtape = false	,SongString = "Amon Amarth - Runes To My Memory",				SongData = "KRUNCH_AMON_AMARTH___RUNES_TO_MY_MEMORY",			station = "KRUNCH" },
	{ mixtape = false	,SongString = "Between the Buried and Me - Obfuscation",			SongData = "KRUNCH_BETWEEN_THE_BURIED_AND_ME___OBFUSCATION",		station = "KRUNCH" },
	{ mixtape = false	,SongString = "The Black Dahlia Murder - Necropolis",				SongData = "KRUNCH_THE_BLACK_DAHLIA_MURDER___NECROPOLIS",		station = "KRUNCH" },
	{ mixtape = false	,SongString = "Black Veil Brides - Perfect Weapon",				SongData = "KRUNCH_BLACK_VEIL_BRIDES___PERFECT_WEAPON",			station = "KRUNCH" },
	{ mixtape = false	,SongString = "Chemlab - Suicide Jag",						SongData = "KRUNCH_CHEMLAB___SUICIDE_JAG",				station = "KRUNCH" },
	{ mixtape = false	,SongString = "The Dillinger Escape Plan - Farewell, Mona Lisa",		SongData = "KRUNCH_THE_DILLINGER_ESCAPE_PLAN___FAREWELL_MONA_LISA",	station = "KRUNCH" },
	{ mixtape = false	,SongString = "Drowning Pool - Feel Like I Do",					SongData = "KRUNCH_DROWNING_POOL___FEEL_LIKE_I_DO",			station = "KRUNCH" },
	{ mixtape = false	,SongString = "Goatwhore - Apocalyptic Havoc",					SongData = "KRUNCH_GOATWHORE___APOCALYPTIC_HAVOC",			station = "KRUNCH" },
	{ mixtape = false	,SongString = "Job for a Cowboy - Regurgitated Disinformation",			SongData = "KRUNCH_JOB_FOR_A_COWBOY___REGURGITATED_DISINFORMATION",	station = "KRUNCH" },
	{ mixtape = false	,SongString = "KMFDM - WWIII",							SongData = "KRUNCH_KMFDM___WWIII",					station = "KRUNCH" },
	{ mixtape = false	,SongString = "Marilyn Manson - Arma-Goddamn-Motherfuckin-Geddon",		SongData = "KRUNCH_MARYLIN_MANSON___ARMAGODDAMNMOTHERFUCKINGGEDDON",	station = "KRUNCH" },
	{ mixtape = false	,SongString = "Mastodon - Divinations",						SongData = "KRUNCH_MASTODON___DIVINATIONS",				station = "KRUNCH" },
	{ mixtape = false	,SongString = "Miss May I - Apologies Are for the Weak",			SongData = "KRUNCH_MISS_MAY_I___APOLOGIES_ARE_FOR_THE_WEAK",		station = "KRUNCH" },
	{ mixtape = false	,SongString = "Opeth - The Lotus Eater",					SongData = "KRUNCH_OPETH___THE_LOTUS_EATERS",				station = "KRUNCH" },
	{ mixtape = false	,SongString = "Otep - Rise, Rebel, Resist",					SongData = "KRUNCH_OTEP___RISE_REBEL_RESIST",				station = "KRUNCH" },
	{ mixtape = false	,SongString = "Shai Hulud - Misanthropy Pure",					SongData = "KRUNCH_SHAI_HULUD___MISANTHROPY_PURE",			station = "KRUNCH" },
	{ mixtape = false	,SongString = "Strapping Young Lad - Love?",					SongData = "KRUNCH_STRAPPING_YOUNG_LAD___LOVE",				station = "KRUNCH" },
	{ mixtape = false	,SongString = "Tugboat - Slow Revolution",					SongData = "KRUNCH_TUGBOAT___SLOW_REVOLUTION",				station = "KRUNCH" },
	{ mixtape = false	,SongString = "You Love Her Coz She's Dead - Engine Wrecker",			SongData = "KRUNCH_YOU_LOVE_HER_COZ_SHES_DEAD___ENGINE_WRECKS",		station = "KRUNCH" },

	-- KLASSIC
	{ mixtape = false	,SongString = "Bach  Brandenburg Concerto No. 3 Allegro",			SongData = "KLASSIC_BACH___BRANDENBURG_CONCERTO_NO_3_ALLEGRO",		station = "KLASSIC" },
	{ mixtape = false	,SongString = "Boccherini  Minuet",						SongData = "KLASSIC_BOCCHERINI___MINUET",				station = "KLASSIC" },
	{ mixtape = false	,SongString = "Chopin  Waltz in D Flat Major Op 64 No 1",			SongData = "KLASSIC_CHOPIN___WALTZ_IN_D_FLAT_MAJOR",			station = "KLASSIC" },
	{ mixtape = false	,SongString = "Dvorak  Humoresque Op 101 No 7",				SongData = "KLASSIC_DVORAK___HUMORESQUE_OP_101_NO_7",			station = "KLASSIC" },
	{ mixtape = false	,SongString = "Handel - Hallelujah from Messiah",				SongData = "KLASSIC_HANDEL___HALLELUJAH_FROM_MESSIAH",			station = "KLASSIC" },
	{ mixtape = false	,SongString = "Liszt - Hungarian Rhapsody No. 2",				SongData = "KLASSIC_LISZT___HUNGARIAN_RHAPSODY",			station = "KLASSIC" },
	{ mixtape = false	,SongString = "Mendelssohn - Spring Song",					SongData = "KLASSIC_MENDELSSOHN___SPRING_SONG",				station = "KLASSIC" },
	{ mixtape = false	,SongString = "Mozart - The Magic Flute: Der Holle Rache",			SongData = "KLASSIC_MOZART___DER_HOLLE_RACHE",				station = "KLASSIC" },
	{ mixtape = false	,SongString = "Mozart - Eine Kleine Nachtmusik: Serenade No 13 in G, Allegro",	SongData = "KLASSIC_MOZART___SERENADE_NO_13_IN_G_ALLEGRO",		station = "KLASSIC" },
	{ mixtape = false	,SongString = "Mozart - Eine Kleine Nachtmusik: Serenade No 13 in G, Rondo",	SongData = "KLASSIC_MOZART___SERENADE_NO_13_IN_G_RONDO",		station = "KLASSIC" },
	{ mixtape = false	,SongString = "Rossini - The Thieving Magpie Overture",				SongData = "KLASSIC_ROSSINI___THE_THIEVING_MAGPIE_OVERTURE",		station = "KLASSIC" },
	{ mixtape = false	,SongString = "Rossini - William Tell Overture",				SongData = "KLASSIC_ROSSINI___THE_WILLIAM_TELL_OVERTURE",		station = "KLASSIC" },
	{ mixtape = false	,SongString = "Saint-Saens - Carnival of Animals: The Fossils",			SongData = "KLASSIC_SAINT_SAENS___CARNIVAL_OF_THE_ANIMALS_THE_FOSSILS",	station = "KLASSIC" },
	{ mixtape = false	,SongString = "Sousa - Stars and Stripes",					SongData = "KLASSIC_SOUSA___THE_STARS_AND_STRIPES_FOREVER",		station = "KLASSIC" },
	{ mixtape = false	,SongString = "Strauss - Blue Danube",						SongData = "KLASSIC_STRAUSS___BLUE_DANUBE",				station = "KLASSIC" },
	{ mixtape = false	,SongString = "Wagner - Ride of the Valkyries",					SongData = "KLASSIC_WAGNER___RIDE_OF_THE_VALKYRIES",			station = "KLASSIC" },
	{ mixtape = false	,SongString = "Waldteufel - Skaters Waltz",					SongData = "KLASSIC_WALDTEUFEL___SKATERS_WALTZ",			station = "KLASSIC" },

	-- ADULT SWIM
	{ mixtape = false	,SongString = "Black Mountain - Let Spirits Ride",				SongData = "SWIM_BLACK_MOUNTAIN___LET_SPIRITS_RIDE",			station = "SWIM" },
	{ mixtape = false	,SongString = "Cerebral Ballzy - Insufficient Fare",				SongData = "SWIM_CEREBRAL_BALLZY___INSUFFICIENT_FAIR",			station = "SWIM" },
	{ mixtape = false	,SongString = "Cheeseburger - Winner",						SongData = "SWIM_CHEESEBURGER___WINNER",				station = "SWIM" },
	{ mixtape = false	,SongString = "Danger Doom - Basketcase",					SongData = "SWIM_DANGERDOOM___BASKET_CASE",				station = "SWIM" },
	{ mixtape = false	,SongString = "Dethklok - The Cyborg Slayers",					SongData = "SWIM_DETHKLOK___THE_CYBORG_SLAYERS",			station = "SWIM" },
	{ mixtape = false	,SongString = "J.G. Thirlwell - No Vacancy",					SongData = "SWIM_J_G_THIRLWELL___NO_VACANCY",				station = "SWIM" },
	{ mixtape = false	,SongString = "Mike Bigga - The War",						SongData = "SWIM_MIKE_BIGGA___THE_WAR",					station = "SWIM" },
	{ mixtape = false	,SongString = "OFWGKTA - Anarchy",						SongData = "SWIM_ODD_FUTURE___ANARCHY",					station = "SWIM" },
	{ mixtape = false	,SongString = "Schooly D - Aqua Teen Hunger Force Theme (Remix)",		SongData = "SWIM_SCHOOLY_D___ATHF_THEME_REMIX",				station = "SWIM" },
	{ mixtape = false	,SongString = "Tim & Eric - Sports (Sports Bar Remix)",				SongData = "SWIM_TIM_AND_ERIC___SPORTS_SPORTS_BAR_REMIX",		station = "SWIM" },
	{ mixtape = false	,SongString = "Unknown Hinson - Save Me From Myself",				SongData = "SWIM_UNKNOWN_HINSON___SAVE_ME_FROM_MYSELF",			station = "SWIM" },
	{ mixtape = false	,SongString = "Wavves - Idiot",							SongData = "SWIM_WAVVES___IDIOT",					station = "SWIM" },

	-- KABRON
	{ mixtape = false	,SongString = "Ambush - Este Reggaeton",					SongData = "KABRON_AMBUSH___ESTE_REGGAETON",				station = "KABRON" },
	{ mixtape = false	,SongString = "Blaster Chicks - Vamonos Hasta Bajo",				SongData = "KABRON_BLASTER_CHICKS___VAMONOS_HASTA_BAJO",		station = "KABRON" },
	{ mixtape = false	,SongString = "Calle Cardona - Get Down",					SongData = "KABRON_CALLE_CARDONA___GET_DOWN",				station = "KABRON" },
	{ mixtape = false	,SongString = "DJ Genesis feat. Shimola - Ella Prenda Gilla",			SongData = "KABRON_DJ_GENESIS___ELLA_PRENDE_GILLA",			station = "KABRON" },
	{ mixtape = false	,SongString = "Don Omar - Virtual Diva",					SongData = "KABRON_DON_OMAR___VIRTUAL_DIVA",				station = "KABRON" },
	{ mixtape = false	,SongString = "FDK - Lujo",							SongData = "KABRON_FDK___LUJO",						station = "KABRON" },
	{ mixtape = false	,SongString = "FDK feat. Pinky - Dejate Llevar",				SongData = "KABRON_FDK_FEAT_PINKY___DEJATE_LLEVAR",			station = "KABRON" },
	{ mixtape = false	,SongString = "Flama - Movimiento Espectacular",				SongData = "KABRON_FLAMA___MOVIMIENTO_ESPECTACULAR",			station = "KABRON" },
	{ mixtape = false	,SongString = "Chacka feat. Kanelo - Friendz",					SongData = "KABRON_FRIENDZ___CHACKA",					station = "KABRON" },
	{ mixtape = false	,SongString = "Mr. Kapri - Maria Juana",					SongData = "KABRON_MR_KAPRI___MARIA_JUANA",				station = "KABRON" },
	{ mixtape = false	,SongString = "Pitbull - Maldito Alcohol",					SongData = "KABRON_PITBULL___MALDITO_ALCOHOL",				station = "KABRON" },
	{ mixtape = false	,SongString = "Prophex - La Turbina",						SongData = "KABRON_PROPHEX___LA_TURBINA",				station = "KABRON" },
	{ mixtape = false	,SongString = "MR-1 and Phophex - Sue Fue La Luz",				SongData = "KABRON_R_1___SE_FUE_LA_LUZ",				station = "KABRON" },
	{ mixtape = false	,SongString = "Reggae Black - Sueltate y Toma",					SongData = "KABRON_REGGAE_BLACK___SUELTATE_Y_TOMA",			station = "KABRON" },
	{ mixtape = false	,SongString = "Vakero - Ponte A Trabajar",					SongData = "KABRON_VAKERO___PONTE_A_TRABAJAR",				station = "KABRON" },
	{ mixtape = false	,SongString = "Villanmosam - Todavia no hay na",				SongData = "KABRON_VILLANMOSAM___TODAVIA_NO_HAY_NA",			station = "KABRON" },

	-- KRHYME
	{ mixtape = false	,SongString = "Amanda Blank - Gimme What You Got",				SongData = "KRHYME_AMANDA_BLANK___GIMME_WHAT_YOU_GOT",			station = "KRHYME" },
	{ mixtape = false	,SongString = "Blakroc - Done Did It feat. Nicole Wray & NOE",			SongData = "KRHYME_BLAKROC___DONE_DID_IT",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Freeway - Throw Your Hands Up",					SongData = "KRHYME_FREEWAY___THROW_YOUR_HANDS_UP",			station = "KRHYME" },
	{ mixtape = false	,SongString = "G-Eazy - My Life Is A Party",					SongData = "KRHYME_G_EASY___MY_LIFE_IS_A_PARTY",			station = "KRHYME" },
	{ mixtape = false	,SongString = "Kanye West - Power",						SongData = "KRHYME_KANYE_WEST___POWER",					station = "KRHYME" },
	{ mixtape = false	,SongString = "KB - Get It In feat. Ammo & K. Madison",				SongData = "KRHYME_KB___GET_IT_IN",					station = "KRHYME" },
	{ mixtape = false	,SongString = "Kurupt - I'm Burnt feat. Problem",				SongData = "KRHYME_KURUPT___IM_BURNT",					station = "KRHYME" },
	{ mixtape = false	,SongString = "Medine - Don't Panik",						SongData = "KRHYME_MEDINE___DONT_PANIK",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Mickey Factz - Paradise",					SongData = "KRHYME_MICKEY_FACTZ___PARADISE",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Mos Def - Quiet Dog",						SongData = "KRHYME_MOS_DEF___QUIET_DOG",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Pharoahe Monch - In The Zone",					SongData = "KRHYME_PHAROAHE_MONCH___IN_THE_ZONE",			station = "KRHYME" },
	{ mixtape = false	,SongString = "Rob Roy - Fur In My Cap",					SongData = "KRHYME_ROB_ROY___FUR_IN_MY_CAP",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Sean Price - Boom Bye Yeah",					SongData = "KRHYME_SEAN_PRICE___BOOM_BYE_YEAH",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Sixx John - Push Play",						SongData = "KRHYME_SIXX_JOHN___PUSH_PLAY",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Southpaw Swagger - Can't Stop Now",				SongData = "KRHYME_SOUTHPAW_SWAGGER___CANT_STOP_NOW",			station = "KRHYME" },
	{ mixtape = false	,SongString = "Sum Kid - The Countdown",					SongData = "KRHYME_SUM_KID___THE_COUNTDOWN",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Tandem - 93 Hardcore",						SongData = "KRHYME_TANDEM___93_HARDCORE",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Tyler, The Creator - Yonkers",					SongData = "KRHYME_TYLER_THE_CREATOR___YONKERS",			station = "KRHYME" },
	{ mixtape = false	,SongString = "Wale - Mirrors feat. Bun B",					SongData = "KRHYME_WALE___MIRRORS",					station = "KRHYME" },
	{ mixtape = false	,SongString = "Yelawolf - Good to Go feat. Bun B",				SongData = "KRHYME_YELAWOLF___GOOD_TO_GO",				station = "KRHYME" },

	-- GENX
	{ mixtape = false	,SongString = "The Black Keys - Next Girl",					SongData = "GENX_THE_BLACK_KEYS___NEXT_GIRL",				station = "GENX" },
	{ mixtape = false	,SongString = "Brooklyn - Volcanology",						SongData = "GENX_BROOKLYN___VOLCANOLOGY",				station = "GENX" },
	{ mixtape = false	,SongString = "The Dear Hunter - In Cauda Venenum",				SongData = "GENX_THE_DEAR_HUNTER___IN_CAUDA_VENENUM",			station = "GENX" },
	{ mixtape = false	,SongString = "Deftones - Diamond Eyes",					SongData = "GENX_DEFTONES___DIAMOND_EYES",				station = "GENX" },
	{ mixtape = false	,SongString = "Delphic - Clarion Call",						SongData = "GENX_DELPHIC___CLARION_CALL",				station = "GENX" },
	{ mixtape = false	,SongString = "The Do - Queen Dot Kong",					SongData = "GENX_THE_DO___QUEEN_DOT_KONG",				station = "GENX" },
	{ mixtape = false	,SongString = "Dragonette - Stupid Grin",					SongData = "GENX_DRAGONETTE___STUPID_GRIN",				station = "GENX" },
	{ mixtape = false	,SongString = "Feeder - Renegades",						SongData = "GENX_FEEDER___RENEGADES",					station = "GENX" },
	{ mixtape = false	,SongString = "Heavy Young Heathens - Sha La La La La",				SongData = "GENX_HEAVY_YOUNG_HEATHENS___SHA_LA_LA_LA_LA",		station = "GENX" },
	{ mixtape = false	,SongString = "Hockey - Too Fake",						SongData = "GENX_HOCKEY___TOO_FAKE",					station = "GENX" },
	{ mixtape = false	,SongString = "JR - Lost Desire",						SongData = "GENX_JR___LOST_DESIRE",					station = "GENX" },
	{ mixtape = false	,SongString = "King Khan and the Shrines - Torture",				SongData = "GENX_KING_KHAN_AND_THE_SHRINES___TORTURE",			station = "GENX" },
	{ mixtape = false	,SongString = "The Lines - El Matador",						SongData = "GENX_THE_LINES___EL_MATADOR",				station = "GENX" },
	{ mixtape = false	,SongString = "Miike Snow - Animal",						SongData = "GENX_MIIKE_SNOW___ANIMAL",					station = "GENX" },
	{ mixtape = false	,SongString = "The Rassle - Born Free",						SongData = "GENX_THE_RASSLE___BORN_FREE",				station = "GENX" },
	{ mixtape = false	,SongString = "Sleigh Bells - Riot Rhythm",					SongData = "GENX_SLEIGH_BELLS___RIOT_RHYTHM",				station = "GENX" },
	{ mixtape = false	,SongString = "Valencia - Stop Searching",					SongData = "GENX_VALENCIA___STOP_SEARCHING",				station = "GENX" },
	{ mixtape = false	,SongString = "White Denim - Paint Yourself",					SongData = "GENX_WHITE_DENIM___PAINT_YOURSELF",				station = "GENX" },

	-- COMMERICALS
	{ mixtape = false	,SongString = "3 Count Casino Commercial 1",					SongData = "COMMERCIAL_3COUNT_CASINO",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "3 Count Casino Commercial 2",					SongData = "COMMERCIAL_3COUNT_CASINO_PITBOSS",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Aisha Commercial",						SongData = "COMMERCIAL_AISHA",						station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Be a Saint Commercial",						SongData = "COMMERCIAL_BE_A_SAINT",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Beyond the Mask Commercial",					SongData = "COMMERCIAL_BEYOND_THE_MASK",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Broken Shillelagh Commercial",					SongData = "COMMERCIAL_BROKEN_SHILLELAGH",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Cement Shoes Commercial",					SongData = "COMMERCIAL_CEMENT_SHOES_THE_MUSICAL_SPOT",			station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Demasking Angel Commercial",					SongData = "COMMERCIAL_DEMASKING_ANGEL",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Dragons and Tears Commercial",					SongData = "COMMERCIAL_DRAGONS_AND_TEARS",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Eric Gryphon Interview Comercial",				SongData = "COMMERCIAL_ERIC_GORPHAN_INTERVIEW",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Feelboss Commercial",						SongData = "COMMERCIAL_FEELBOSS",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Friendly Fire Commercial",					SongData = "COMMERCIAL_FRIENDLY_FIRE",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Gangsters in Space Commercial",					SongData = "COMMERCIAL_GANGSTERS_SPACE",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Professor Genki Mall Commercial",				SongData = "COMMERCIAL_GENKI_MALL_APPEARANCE",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Professor Genki Reality Climax Commercial",			SongData = "COMMERCIAL_GENKI_REALITY_CLIMAX",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Professor Genki World Commercial",				SongData = "COMMERCIAL_GENKI_WORLD",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Josh Birk Special Commercial",					SongData = "COMMERCIAL_JOSH_BIRK_SPECIAL",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Kitty Style Commercial",						SongData = "COMMERCIAL_KITTY_STYLE",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Let's Pretend Commercial",					SongData = "COMMERCIAL_LETS_PRETEND",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Lowdown Conspiracy Commercial",					SongData = "COMMERCIAL_LOWDOWN_CONSPIRACY",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Lowdown Online Addiction Commercial",				SongData = "COMMERCIAL_LOWDOWN_ONLINE_ADDICTION",			station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Lowdown Phillipe Commerical",					SongData = "COMMERCIAL_LOWDOWN_PHILLIPE",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Lowdown Sex Trade Commercial",					SongData = "COMMERCIAL_LOWDOWN_SEX_TRADE",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Mayor Reynolds Commercial 1",					SongData = "COMMERCIAL_MAYOR_REYNOLDS_1",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Mayor Reynolds Commercial 2",					SongData = "COMMERCIAL_MAYOR_REYNOLDS_2",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Mayor Reynolds Commercial 3",					SongData = "COMMERCIAL_MAYOR_REYNOLDS_3",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Mayor Reynolds Commercial 4",					SongData = "COMMERCIAL_MAYOR_REYNOLDS_4",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Mayor Reynolds Commercial 5",					SongData = "COMMERCIAL_MAYOR_REYNOLDS_5",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Murderbrawl XXXI Commercial 1",					SongData = "COMMERCIAL_MURDERBRAWL_31",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Murderbrawl XXXI Commercial 2",					SongData = "COMMERCIAL_MURDERBRAWL31",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Nobody Loves Me Commercial",					SongData = "COMMERCIAL_NOBODY_LOVES_ME",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Planet Saints Commercial",					SongData = "COMMERCIAL_PLANET_SAINTS_JINGLE_2",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Powder Room Commercial",						SongData = "COMMERCIAL_POWDER",						station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "PSA Boots Commercial",						SongData = "COMMERCIAL_PSA_BOOTS",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "PSA Brass Knuckles Commercial",					SongData = "COMMERCIAL_PSA_BRASS_KNUCKLES",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "PSA Cologne Commercial",						SongData = "COMMERCIAL_PSA_COLOGNE",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "PSA Condoms Commercial",						SongData = "COMMERCIAL_PSA_CONDOMS",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "PSA Men's Suits Commercial",					SongData = "COMMERCIAL_PSA_MENS_SUITS",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Regicide Commercial",						SongData = "COMMERCIAL_REGICIDE",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Rim Jobs Commercial",						SongData = "COMMERCIAL_RIM_JOBS",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Safe Word Commercial",						SongData = "COMMERCIAL_SAFE_WORD",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Saints Flow Commercial",						SongData = "COMMERCIAL_SAINTS_FLOW_DRINK",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Sleep with Shaundi Commercial",					SongData = "COMMERCIAL_SLEEP_WITH_SHAUNDI",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "STAG Cyrus Temple Commercial",					SongData = "COMMERCIAL_STAG_CYRUS_TEMPLE",				station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "STAG Josh Birk Commercial",					SongData = "COMMERCIAL_STAG_JOSH_BIRK",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "STAG Welcome Commercial",					SongData = "COMMERCIAL_STAG_WELCOME",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Steelport Commercial",						SongData = "COMMERCIAL_STEELPORT_30",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Ultor Commercial",						SongData = "COMMERCIAL_ULTOR_VOICE",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Jane Valdorama Commercial",					SongData = "COMMERCIAL_VALDORAMA",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Nightblade Commercial 1",					SongData = "COMMERCIAL_NIGHTBLADE_01",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Nightblade Commercial 2",					SongData = "COMMERCIAL_NIGHTBLADE_02",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Nightblade Commercial 3",					SongData = "COMMERCIAL_NIGHTBLADE_03",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Nightblade Commercial 4",					SongData = "COMMERCIAL_NIGHTBLADE_04",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Nightblade Commercial 5",					SongData = "COMMERCIAL_NIGHTBLADE_05",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Nightblade Commercial 6",					SongData = "COMMERCIAL_NIGHTBLADE_06",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Nightblade Commercial 7",					SongData = "COMMERCIAL_NIGHTBLADE_07",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Nightblade Commercial 8",					SongData = "COMMERCIAL_NIGHTBLADE_08",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Nightblade Commercial 9",					SongData = "COMMERCIAL_NIGHTBLADE_09",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Nightblade Commercial 10",					SongData = "COMMERCIAL_NIGHTBLADE_10",					station = "COMMERCIAL", event = "RADIO_COMMERCIALS" },

	-- NEWSBREAKS AND NEWSCASTS
	{ mixtape = false	,SongString = "When Good Heists go Bad Newscast",				SongData = "M01",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "I'm Free Falling Newscast",					SongData = "M02",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "We're Going to Need Bigger Guns Newscast",			SongData = "M03",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Steelport Here I Am Newscast",					SongData = "M04",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Party Time Newscast",						SongData = "M05",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Hit the Powder Room Newscast",					SongData = "NEWSCAST_SH01",						station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "The Belgian Problem Destroy Choice Newscast",			SongData = "M06_BUILDING_GONE",						station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "The Belgian Problem Save Choice Newscast",			SongData = "M06_BUILDING_STAY",						station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Return to Steelport Newscast",					SongData = "M07",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Trojan Whores Newscast",						SongData = "M08",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Pimps Up, Hos Down Newscast",					SongData = "NEWSCAST_SH02",						station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "The Ho Boat Newscast",						SongData = "M09",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Gang Bang Newscast",						SongData = "M10",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Convoy Decoy Newscast",						SongData = "M11",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Nyte Blade's Return Newscast",					SongData = "M12",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "STAG Party Newscast",						SongData = "M13",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Live! With Killbane Newscast",					SongData = "M14",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Learning Computer Newscast",					SongData = "M15",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Stop All the Downloading Newscast",				SongData = "NEWSCAST_SH03",						station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "deckers.die Newscast",						SongData = "M16",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "My Name is Cyrus Temple Newscast",				SongData = "M17",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Air Steelport Newscast",						SongData = "M18",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Zombie Attack! Newscast",					SongData = "M19",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Remote Chance Newscast",						SongData = "M20",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "3 Count Beatdown Newscast",					SongData = "NEWSCAST_SH04",						station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Murderbrawl XXXI Newscast",					SongData = "M21",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Three Way Killbane Choice Newscast",				SongData = "M22_KILL_KILLBANE",						station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Three Way Hero Choice Newscast",					SongData = "M22_SAVE_SAINTS",						station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "STAG Film Newscast",						SongData = "M23",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Gangstas in Space Newscast",					SongData = "M24",							station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Nyteblade Protest Newscast",					SongData = "NEWSCAST_NIGHTBLADE_PROTEST_1",				station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Nyteblade STAG Newscast 1",					SongData = "NEWSCAST_NIGHTBLADE_STAG_1",				station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Nyteblade STAG Newscast 2",					SongData = "NEWSCAST_NIGHTBLADE_STAG_2",				station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Saints Betrayal Newscast 1",					SongData = "NEWSCAST_SAINTS_BETRAYAL_1",				station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Saints Betrayal Newscast 2",					SongData = "NEWSCAST_SAINTS_BETRAYAL_2",				station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Saints Celebrity Newscast 1",					SongData = "NEWSCAST_SAINTS_CELEBRITY_1",				station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Saints Celebrity Newscast 2",					SongData = "NEWSCAST_SAINTS_CELEBRITY_2",				station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Saints Celebrity Newscast 3",					SongData = "NEWSCAST_SAINTS_CELEBRITY_3",				station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "STAG Protest Newscast 1",					SongData = "NEWSCAST_STAG_PROTEST_1",					station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "STAG Protest Newscast 2",					SongData = "NEWSCAST_STAG_PROTEST_2",					station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "STAG Rallies Newscast 1",					SongData = "NEWSCAST_STAG_RALLIES_1",					station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "STAG Rallies Newscast 2",					SongData = "NEWSCAST_STAG_RALLIES_2",					station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Weather Fall Newscast",						SongData = "NEWSCAST_WEATHER_FALL",					station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Weather Halloween Newscast 1",					SongData = "NEWSCAST_WEATHER_HALLOWEEN_1",				station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Weather Halloween Newscast 2",					SongData = "NEWSCAST_WEATHER_HALLOWEEN_2",				station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Weather Winter Newscast 1",					SongData = "NEWSCAST_WEATHER_WINTER_1",					station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Weather Winter Newscast 2",					SongData = "NEWSCAST_WEATHER_WINTER_2",					station = "NEWS", event = "RADIO_COMMERCIALS" },
	{ mixtape = false	,SongString = "Killbane Interview Part 1",					SongData = "M14_INTERVIEW_PART1",					station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Killbane Interview Part 2",					SongData = "M14_INTERVIEW_PART2",					station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Killbane Interview Part 3",					SongData = "M14_INTERVIEW_PART3",					station = "NEWS", event = "RADIO_NEWS_BREAKS" },
	{ mixtape = false	,SongString = "Killbane Interview Part 4",					SongData = "M14_INTERVIEW_PART4",					station = "NEWS", event = "RADIO_NEWS_BREAKS" },

	-- MISC MUSIC
	{ mixtape = false	,SongString = "Unused Whored Menu Music",	SongData = "WHORED_MODE",			station = "MISC", event = "UI_MUSIC" },
	{ mixtape = false	,SongString = "Whored Mode Music",	SongData = "UI_WHR_CNT_GO",			station = "MISC", is_mission_song = true },
	{ mixtape = false	,SongString = "Loading screen",	SongData = "LOAD_MUSIC",			station = "MISC", is_mission_song = true },
	{ mixtape = false	,SongString = "Sleazy music",	SongData = "AMB_DT_SLEAZYMUSIC",	station = "MISC", is_mission_song = true },
	{ mixtape = false	,SongString = "Mission Complete",	SongData = "MISSION_COMPLETION",			station = "MISC", event = "UI_MUSIC" },

	-- MISSION MUSIC
	-- These need modified audio_banks.xtbl and *.bnk_pc files from "Sandbox+ - Things To Do In Steelport Edition"
--[[
	{ mixtape = false	,SongString = "Party Time - Morningstar music (helicopter chase)",											SongData = "M05_MORNINGSTAR_MUSIC",							station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "Trojan Whores - Saints music (Ben and Aaron Wheeler - Honeys in the Place, I'm a VIP)",		SongData = "M05_SAINTS_MUSIC",								station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "deckers.die - Part 1",																		SongData = "M16_MUSIC_01_PLAY",								station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "deckers.die - Part 2",																		SongData = "M16_MUSIC_01B_PLAY",							station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "deckers.die - Part 3",																		SongData = "M16_MUSIC_02_PLAY",								station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "deckers.die - Tank battle",																	SongData = "TANK_BATTLE_MUSIC",								station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "deckers.die - Tank battle win",																SongData = "TANK_BATTLE_MUSIC_WIN",							station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "deckers.die - Pre-Boss",																		SongData = "M16_PRE_BOSS_MUSIC",							station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "deckers.die - Boss fight",																	SongData = "M16_BOSS_MUSIC_PLAY",							station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "GIS - Hangar 18 1/2 - Part 1",																SongData = "M02_PART1_MUSIC_START",							station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "GIS - Hangar 18 1/2 - Part 2",																SongData = "M02_PART2_MUSIC_START",							station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "GIS - Hangar 18 1/2 - Part 3",																SongData = "M02_PART3_MUSIC_START",							station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "GIS - Hangar 18 1/2 - Checkpoint 1",															SongData = "M02_MUSIC_CHECKPOINT_1",						station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "GIS - Hangar 18 1/2 - Checkpoint 3",															SongData = "M02_MUSIC_CHECKPOINT_3",						station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "TTWC - Send in the clones - Objective A",													SongData = "DLC3_M03_MUS_OBJECTIVE_A",						station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "TTWC - Send in the clones - Combat A",														SongData = "DLC3_M03_MUS_COMBAT_A",							station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "TTWC - Send in the clones - Objective B",													SongData = "DLC3_M03_MUS_OBJECTIVE_B",						station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "TTWC - Send in the clones - Combat B",														SongData = "DLC3_M03_MUS_COMBAT_B",							station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "TTWC - Send in the clones - Go to bridge",													SongData = "DLC3_M03_MUS_GO_TO_BRIDGE",						station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "TTWC - Send in the clones - Go to bridge (checkpoint)",										SongData = "DLC3_M03_MUS_GO_TO_BRIDGE_CHECKPOINT",			station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "TTWC - Send in the clones - Bridge battle",													SongData = "DLC3_M03_MUS_BRIDGE_BATTLE",					station = "MISSION", is_mission_song = true },
	{ mixtape = false	,SongString = "TTWC - Send in the clones - Bridge battle (checkpoint)",										SongData = "DLC3_M03_MUS_BRIDGE_BATTLE_CHECKPOINT",			station = "MISSION", is_mission_song = true },
--]]
}

-- Internal Station Names
OFAP_STATIONS = {
	"OFF", "GENX", "KRHYME", "K12", "KLASSIC", "SWIM", "KABRON", "KRUNCH", "MIXX", "COMMERCIAL", "NEWS", "MISC",
	--"MISSION"
}

-- Displayed Station Names
OFAP_DISPLAYED_STATION_NAMES = {
	["GENX"] = "89.0 GENERATION X",
	["KRHYME"] = "95.4 KRHYME FM",
	["K12"] = "97.6 K12 FM",
	["KLASSIC"] = "102.4 KLASSIC FM",
	["SWIM"] = "ADULT SWIM WDDTCPDG",
	["KABRON"] = "KABRON 104.2",
	["KRUNCH"] = "106.66 THE BLOOD",
	["MIXX"] = "107.77 THE MIX FM",
	["COMMERCIAL"] = "ADVERT FM",
}

Ofap_radio_table = {}	-- Radio Table
Ofap_song_number = {}	-- Current song numbers
Ofap_last_message_handle = -1	-- Last message handle
Ofap_audio_handle = -1	-- Current song's audio handle
Ofap_current_station = 1	-- Current station ID

-- Main Thread of On-Foot Audio Player for SRTT
-- Run it by `thread_new("ofap_main_thread")` from sr3_city_main()
function ofap_main_thread()
	-- Populate song list
	if OFAP_SHUFFLE then
		ofap_shuffle(OFAP_RADIODATA)
	end
	ofap_populate_radio_table()

	-- Add Mixtape to selectable station
	if (Ofap_radio_table["MIXTAPE"] ~= nil) and (#Ofap_radio_table["MIXTAPE"] > 0) then
		OFAP_STATIONS[#OFAP_STATIONS + 1] = "MIXTAPE"
	end
	
	-- Wait until the loading screen goes away
	fade_in_block()
	
	while true do
		thread_yield()

		-- If a cutscene is active, wait until it's over
		while not cutscene_play_check_done() do
			thread_yield()
		end

		-- Check current vehicle
		local carradio = false	-- true if we're using car radio (disables on-foot audio)
		local myride = get_char_vehicle_name(LOCAL_PLAYER)
		if myride ~= "" then
			if not OFAP_CAR_RADIO then
				-- Turn off the car radio
				if radio_get_station(myride) ~= 2 then
					radio_set_station(myride, 2)
				end
				vehicle_set_radio_controls_locked(myride, true)
			else
				carradio = true
			end
		end

		if not carradio then
			-- Station Change buttons
			local change = 0
			if player_action_just_pressed("CBA_VDC_PREV_RADIO") then
				change = -1
			elseif player_action_just_pressed("CBA_VDC_NEXT_RADIO") then
				change = 1
			end
			-- Switch the station
			if change ~= 0 then
				-- Stop current music
				ofap_stop_current_song()
				
				Ofap_current_station = Ofap_current_station + change
				if Ofap_current_station < 1 then
					Ofap_current_station = #OFAP_STATIONS
				end
				if Ofap_current_station > #OFAP_STATIONS then
					Ofap_current_station = 1
				end
				
				audio_object_post_event("UI_STAG_PROTOTYPE_SCROLL", nil, nil, LOCAL_PLAYER)
				
				-- Station Change Notification
				if not OFAP_SHOW_SONG_TITLE then
					local displayed_station_name = ofap_get_displayed_station_name()
					ofap_message("STATION:\n"..displayed_station_name.."\n("..Ofap_current_station.."/"..tostring(#OFAP_STATIONS)..")")
				end
			end

			if (Ofap_audio_handle == -1) or (not audio_is_playing(Ofap_audio_handle)) then
				-- Check if the current song ended, if so play the new one
				local station_name = OFAP_STATIONS[Ofap_current_station]
				local displayed_station_name = ofap_get_displayed_station_name()
				local station_data = Ofap_radio_table[station_name]
				
				if (station_data ~= nil) and (#station_data >= 1) then
					local song_number = Ofap_song_number[station_name]
					if song_number == nil then
						song_number = 0
					end
					song_number = song_number + 1
					if song_number > #station_data then
						song_number = 1
					end

					local song = station_data[song_number]
					if song ~= nil then
						if song.is_mission_song then
							Ofap_audio_handle = audio_object_post_event(song.SongData, nil, nil, LOCAL_PLAYER)
						else
							local audio_event_name = song.event
							if audio_event_name == nil then
								audio_event_name = "RADIO_SONGS"
							end
							Ofap_audio_handle = audio_object_post_event(audio_event_name, audio_event_name, song.SongData, LOCAL_PLAYER)
						end

						-- New Song Notification
						if OFAP_SHOW_SONG_TITLE then
							ofap_message("STATION:\n"..displayed_station_name.."\n("..Ofap_current_station.."/"..tostring(#OFAP_STATIONS)..")\n\nNOW PLAYING:\n"..song.SongString.."\n("..tostring(song_number).."/"..tostring(#station_data)..")", 8)
						end
					end

					Ofap_song_number[station_name] = song_number
				elseif change ~= 0 then
					-- Station changed to "OFF"
					if OFAP_SHOW_SONG_TITLE then
						ofap_message("STATION:\n"..displayed_station_name.."\n("..Ofap_current_station.."/"..tostring(#OFAP_STATIONS)..")")
					end
				end
			else
				-- Song is still playing

				-- Check for the specific key, and if pressed, skip to the next music
				if player_action_just_pressed("CBA_GAC_TAKE_SCREENSHOT") then
					ofap_stop_current_song()
				end
			end
		else
			-- Player entered a car so turn off our audio
			ofap_stop_current_song()
			ofap_message_clear()
		end
	end
end

-- Get the user-facing Station Name
function ofap_get_displayed_station_name(id)
	if id == nil then
		id = Ofap_current_station
	end
	local station_name = OFAP_STATIONS[id]
	local displayed_station_name = OFAP_DISPLAYED_STATION_NAMES[station_name]
	if displayed_station_name == nil then
		return station_name
	end
	return displayed_station_name
end

-- Shuffle elements in the table
function ofap_shuffle(table)
	local tmpCounter = #table
	while tmpCounter >= 2 do
		local random_pos = rand_int(1,tmpCounter)
		table[tmpCounter], table[random_pos] = table[random_pos], table[tmpCounter]
		tmpCounter = tmpCounter - 1
	end
	return table
end

-- Populate radio song list
function ofap_populate_radio_table()
	for i, song in pairs(OFAP_RADIODATA) do
		local station_name = song.station
		
		--debug_print("Adding song " .. song.SongString .. "\n")
		
		if Ofap_radio_table[station_name] == nil then
			--debug_print("Creating station table for "..station_name.."\n")
			Ofap_radio_table[station_name] = {}
		end
		
		local num = #Ofap_radio_table[station_name]
		Ofap_radio_table[station_name][num + 1] = song
		
		--debug_print("Added song to "..station_name.." #"..tostring(num + 1).."\n")
		
		-- If mixtape flag is true, add this song to mixtape station too
		if song.mixtape then
			if Ofap_radio_table["MIXTAPE"] == nil then
				--debug_print("Creating MIXTAPE table\n")
				Ofap_radio_table["MIXTAPE"] = {}
			end
			local mixtape_num = #Ofap_radio_table["MIXTAPE"]
			Ofap_radio_table["MIXTAPE"][mixtape_num + 1] = song
			--debug_print("Added song to MIXTAPE #"..tostring(num + 1).."\n")
		end
	end
end

-- Stop Current Song
function ofap_stop_current_song()
	if Ofap_audio_handle ~= -1 then
		audio_stop(Ofap_audio_handle)
		Ofap_audio_handle = -1
	end
end

-- Clear last displayed message
function ofap_message_clear()
	if Ofap_last_message_handle ~= -1 then
		message_remove(Ofap_last_message_handle, false)
	end
	Ofap_last_message_handle = -1
end

-- Show message
function ofap_message(msg, duration)
	if duration == nil then
		duration = 5
	end
	ofap_message_clear()
	Ofap_last_message_handle = message(msg, duration, false, SYNC_LOCAL)
end

